routes/web.php
<?php

use App\Http\Controllers\AuthController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\NoteController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\CategoryController;

Route::group(['middleware' => 'auth'], function () {
    Route::get('/', function () {
        return view('welcome');
    })->name('home');

    // Categories
    Route::resource('categories', CategoryController::class);

    // Notes
    Route::resource('notes', NoteController::class);

    // Tasks`
    Route::resource('tasks', TaskController::class);


    // Logout
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');
});

Route::group(['middleware' => 'guest'], function () {
    Route::get('login', [AuthController::class, 'login'])->name('login');
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
    Route::get('register', [AuthController::class, 'register'])->name('register');
    Route::post('signup', [AuthController::class, 'signup'])->name('singup');
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\User;
use App\Models\Note;

class Category extends Model
{
    use HasFactory;

    protected $fillable = [
        'user_id',
        'name',
        'position',
    ];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function notes()
    {
        return $this->belongsToMany(Note::class);
    }
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Models\Category;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;

class CategoryController extends Controller
{
    public function __construct()
    {
        $this->authorizeResource(Category::class, 'category');
    }

    public function index()
    {
        $user = Auth::user();

        $categories = $user->categories()->orderBy('position')->get();

        return view('categories/index', [
            'categories' => $categories,
        ]);
    }

    public function show(Category $category)
    {
        return view('categories/show', [
            'category' => $category,
        ]);
    }

    public function edit(Category $category)
    {
        return view('categories/edit', [
            'category' => $category,
        ]);
    }

    public function create()
    {
        return view('categories/create');
    }

    public function destroy(Category $category)
    {
        $category->delete();

        return to_route('categories.index');
    }

    public function store(Request $request)
    {
        $user = Auth::user();

        $data = $request->validate([
            'name' => [
                'required',
                Rule::unique('categories')->where(function ($query) use ($user) {
                    return $query->where('user_id', $user->id);
                })
            ],
            'position' => [
                'required',
                'integer',
            ],
        ]);


        $user->categories()->create($data);

        return to_route('categories.index');
    }

    public function update(Request $request, Category $category)
    {
        $user = Auth::user();

        $data = $request->validate([
            'name' => [
                'required',
                Rule::unique('categories')->where(function ($query) use ($user) {
                    return $query->where('user_id', $user->id);
                })->ignore($category->id),
            ],
            'position' => 'required|integer',
        ]);

        $category->update($data);

        return to_route('categories.index');
    }
}

resources/views/categories/create.blade.php
@extends('layout')

@section('title', 'Create Category')

@section('body')

@include('partials/top-nav', [
    'title' => 'Categories'
])

@include('partials/errors')

    <form action="{{ route('categories.store') }}" method="post">
        @csrf()
        <label for="name">Name</label>
        <input type="text" name="name" id="name" autofocus>

        <label for="position">Position</label>
        <input type="number" name="position" id="position">

        <input type="reset" value="Rest" style="float: left;">
        <input type="submit" value="Create">
    </form>
@endsection

resources/views/categories/edit.blade.php
@extends('layout')

@section('title', 'Edit Category')

@section('links')
<a href="{{ route('categories.show', ['category' => $category['id']]) }}">View</a> |
<form class="delete-form" method="post" action="{{ route('categories.destroy', ['category' => $category['id']]) }}">
    @method('DELETE')
    @csrf()

    <input class="delete-btn" type="submit" value="Delete">
</form>
@endsection

@section('body')

@include('partials/top-nav', [
    'title' => 'Categories'
])

@include('partials/errors')
    <form action="{{ route('categories.update', [
        'category' => $category['id']
    ]) }}" method="post">
        @method('PUT')
        @csrf()
        <label for="name">Name</label>
        <input type="text" name="name" id="name" value="{{ $category['name'] }}">

        <label for="position">Position</label>
        <input type="number" name="position" id="position" value="{{ $category['position'] }}">

        <input type="reset" value="Rest" style="float: left;">
        <input type="submit" value="Update">
    </form>
    @endsection

resources/views/categories/index.blade.php
@extends('layout')

@section('title', 'All Cateogries')

@section('links')
<a href="{{ route('categories.create') }}">New Category</a>
@endsection

@section('body')
    @include('partials/top-nav', [
        'title' => 'Categories'
    ])


    <table>
        <tr>
            <th>ID</th>
            <th>Name</th>
            <th>Position</th>
            <th>Actions</th>
        </tr>


        @foreach ($categories as $category)
        <tr>
            <td>{{ $category['id'] }}</td>
            <td>{{ str_limit($category['name'], 10) }}</td>
            <td>{{ $category['position'] }}</td>
            <td>
                <a href="{{ route('categories.edit', [
                    'category' => $category['id']
                ]) }}">Edit</a> |
                <a href="{{ route('categories.show', [
                    'category' => $category['id']
                ]) }}">View</a> |

                <form class="delete-form" method="post" action="{{ route('categories.destroy', [
                    'category' => $category['id']
                ]) }}">
                    @method('DELETE')
                    @csrf()

                    <input class="delete-btn" type="submit" value="Delete">
                </form>
            </td>
        </tr>
        @endforeach

    </table>


    @endsection

resources/views/categories/show.blade.php
@extends('layout')

@section('title', 'View category')

@section('links')
<a href="{{ route('categories.edit', ['category' => $category['id']]) }}">Edit</a> |
<form class="delete-form" method="post" action="{{ route('categories.destroy', ['category' => $category['id']]) }}">
    @method('DELETE')
    @csrf()

    <input class="delete-btn" type="submit" value="Delete">
</form>
@endsection

@section('body')
    @include('partials/top-nav', [
        'title' => 'Categories'
    ])
    <div>
        <h3>Name</h3>
        {{ $category['name'] }}

        <h3>Position</h3>
        {{ $category['position'] }}
    </div>
@endsection